/* File       : countcust.p 
   Author     : Peter van Dam (Netsetup)
   Description: This program creates a dynamic buffer and query 
                with proper cleanup 
*/

DEF VAR hQuery AS HANDLE NO-UNDO.
DEF VAR hBuffer AS HANDLE NO-UNDO.
DEF VAR iCount AS INTEGER NO-UNDO.

CREATE BUFFER hBuffer FOR TABLE "customer".
CREATE QUERY hQuery.
hQuery:SET-BUFFERS(hBuffer).
hQuery:QUERY-PREPARE("FOR EACH customer NO-LOCK").
hQuery:QUERY-OPEN().
hQuery:GET-FIRST().

DO WHILE hBuffer:AVAILABLE:
  iCount = iCount + 1.
  hQuery:GET-NEXT().
END.


MESSAGE iCount "customers found" VIEW-AS ALERT-BOX.

hQuery:QUERY-CLOSE().
DELETE OBJECT hQuery.
DELETE OBJECT hBuffer.

