/* File       : countcust3.p 
   Author     : Peter van Dam (Netsetup)
   Description: This program publishes the query expression for the
                Query Tester
*/

DEF VAR hQuery AS HANDLE NO-UNDO.
DEF VAR hBuffer AS HANDLE NO-UNDO.
DEF VAR iCount AS INTEGER NO-UNDO.

CREATE BUFFER hBuffer FOR TABLE "customer".
CREATE QUERY hQuery.
hQuery:SET-BUFFERS(hBuffer).
hQuery:QUERY-PREPARE("FOR EACH customer where city = 'boston' NO-LOCK").
/* Publish information about this query */
PUBLISH "query" (INPUT hQuery:PREPARE-STRING).
hQuery:QUERY-OPEN().
hQuery:GET-FIRST().

DO WHILE hBuffer:AVAILABLE:
  iCount = iCount + 1.
  hQuery:GET-NEXT().
END.


MESSAGE iCount "customers found in Boston" VIEW-AS ALERT-BOX.

hQuery:QUERY-CLOSE().
DELETE OBJECT hQuery.
DELETE OBJECT hBuffer.

