/* File       : countcust4.p 
   Author     : Peter van Dam (Netsetup)
   Description: This program logs information about an individual query 
*/

DEF VAR hQuery AS HANDLE NO-UNDO.
DEF VAR hBuffer AS HANDLE NO-UNDO.
DEF VAR iCount AS INTEGER NO-UNDO.

CREATE BUFFER hBuffer FOR TABLE "customer".
CREATE QUERY hQuery.
hQuery:SET-BUFFERS(hBuffer).
/* Log information about this query */
LOG-MANAGER:LOG-ENTRY-TYPES = "qryinfo:2".
hQuery:BASIC-LOGGING = TRUE.
hQuery:QUERY-PREPARE("FOR EACH customer where city = 'boston' NO-LOCK BY name").
hQuery:QUERY-OPEN().
hQuery:GET-FIRST().

DO WHILE hBuffer:AVAILABLE:
  iCount = iCount + 1.
  hQuery:GET-NEXT().
END.


MESSAGE iCount "customers found in Boston" VIEW-AS ALERT-BOX.

hQuery:QUERY-CLOSE().
DELETE OBJECT hQuery.
DELETE OBJECT hBuffer.

