&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  Set Open Edge 10 dynamic logging settings
  
  Author: Peter van Dam

  Created: March 2004

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE TEMP-TABLE t-log
       FIELD iorde AS INT
       FIELD ntype AS CHAR
       FIELD nlabe AS CHAR FORMAT "x(33)"
       FIELD ilevemin AS INT FORMAT "9" INITIAL 2
       FIELD ilevemax AS INT FORMAT "9" INITIAL 4
       FIELD htype# AS WIDGET-HANDLE 
       FIELD hleve# AS WIDGET-HANDLE 
       INDEX iorde IS UNIQUE PRIMARY iorde
       INDEX ntype IS UNIQUE ntype.

DEF VAR giorde# AS INT NO-UNDO.
DEF VAR gstype# AS CHAR INITIAL "4GLTRACE,4GLMESSAGES,DYNOBJECTS.DB,DYNOBJECTS.UI,DYNOBJECTS.XML,DYNOBJECTS.OTHER,QRYINFO,PROEVENTS.UI.CHAR,PROEVENTS.UI.COMMAND,PROEVENTS.OTHER,SAX".
DEF VAR gsdesc# AS CHAR INITIAL "4GL Trace,4GL Messages,Dynamic Database Objects,Dynamic UI Objects,Dynamic XML Objects,Other Dynamic Objects,Query Information,Printable Character Events,Non-printable UI Events,Other Events,SAX Parser".
DEF VAR ghfram# AS WIDGET-HANDLE NO-UNDO.

DO giorde# = 1 TO NUM-ENTRIES(gstype#):
  CREATE t-log.
  ASSIGN t-log.iorde = giorde#
         t-log.ntype = ENTRY(giorde#,gstype#)
         t-log.nlabe = ENTRY(giorde#,gsdesc#).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-1 nfile# BtnOK BtnDone-2 
&Scoped-Define DISPLAYED-OBJECTS nfile# 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BtnDone-2 DEFAULT 
     LABEL "&Done" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON BtnOK AUTO-GO DEFAULT 
     LABEL "Apply" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE VARIABLE nfile# AS CHARACTER FORMAT "X(256)":U INITIAL "mylog.lg" 
     LABEL "Log file" 
     VIEW-AS FILL-IN 
     SIZE 28 BY 1 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 61 BY 17.62.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     nfile# AT ROW 2.91 COL 16 COLON-ALIGNED
     BtnOK AT ROW 20.05 COL 4
     BtnDone-2 AT ROW 20.05 COL 50
     RECT-1 AT ROW 1.71 COL 4
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 67 BY 20.76
         DEFAULT-BUTTON BtnDone-2.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Dynamic Debugging Logging Settings"
         HEIGHT             = 20.81
         WIDTH              = 66.8
         MAX-HEIGHT         = 31.86
         MAX-WIDTH          = 128.4
         VIRTUAL-HEIGHT     = 31.86
         VIRTUAL-WIDTH      = 128.4
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Dynamic Debugging Logging Settings */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Dynamic Debugging Logging Settings */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnDone-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnDone-2 C-Win
ON CHOOSE OF BtnDone-2 IN FRAME DEFAULT-FRAME /* Done */
DO:
  &IF "{&PROCEDURE-TYPE}" EQ "SmartPanel" &THEN
    &IF "{&ADM-VERSION}" EQ "ADM1.1" &THEN
      RUN dispatch IN THIS-PROCEDURE ('exit').
    &ELSE
      RUN exitObject.
    &ENDIF
  &ELSE
      APPLY "CLOSE":U TO THIS-PROCEDURE.
  &ENDIF
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnOK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnOK C-Win
ON CHOOSE OF BtnOK IN FRAME DEFAULT-FRAME /* Apply */
DO:
  RUN setLogging IN THIS-PROCEDURE.
  RUN refreshScreen IN THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

ASSIGN ghfram# = FRAME {&FRAME-NAME}:HANDLE.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN initializeScreen IN THIS-PROCEDURE.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY nfile# 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE RECT-1 nfile# BtnOK BtnDone-2 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeScreen C-Win 
PROCEDURE initializeScreen :
/*------------------------------------------------------------------------------
  Create the screen according to t-log
------------------------------------------------------------------------------*/

  DEF VAR htext# AS WIDGET-HANDLE NO-UNDO.
  DEF VAR sitem# AS CHAR NO-UNDO.
  DEF VAR ileve# AS INT NO-UNDO.
           
  FOR EACH t-log:

    CREATE TOGGLE-BOX t-log.htype
           ASSIGN FRAME = ghfram#
                  LABEL = t-log.nlabe 
                  COLUMN = 10
                  ROW = 4 + t-log.iorde * 1.2
                  HIDDEN = FALSE
                  SENSITIVE = TRUE.

    CREATE COMBO-BOX t-log.hleve#
              ASSIGN FRAME = ghfram#
                     DATA-TYPE = "INTEGER"
                     FORMAT = "9"
                     COLUMN = t-log.htype:COLUMN + 39
                     WIDTH = 10
                     ROW = t-log.htype:ROW
                     HIDDEN = FALSE
                     SENSITIVE = TRUE.

    ASSIGN sitem# = "".
    DO ileve# = t-log.ilevemin TO t-log.ilevemax:
      ASSIGN sitem# = TRIM(SUBSTITUTE("&1,&2", sitem#, ileve#),",")
             t-log.hleve#:LIST-ITEMS = sitem#
             t-log.hleve#:INNER-LINES = NUM-ENTRIES(sitem#).
      ASSIGN t-log.hleve#:SCREEN-VALUE = STRING(t-log.ilevemax) NO-ERROR.
    END.

    CREATE TEXT htext#
           ASSIGN FRAME = ghfram#
                  FORMAT = "x(6)"
                  SCREEN-VALUE = "Level:"
                  ROW = t-log.hleve#:ROW + (t-log.hleve#:HEIGHT - FONT-TABLE:GET-TEXT-HEIGHT-CHARS) / 2
                  COLUMN = t-log.hleve#:COLUMN - (FONT-TABLE:GET-TEXT-WIDTH-CHARS("Level:") + 1)
                  WIDTH = FONT-TABLE:GET-TEXT-WIDTH-CHARS("Level:")
                  HIDDEN = FALSE.
                  
  END.
 
  RUN refreshScreen IN THIS-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refreshScreen C-Win 
PROCEDURE refreshScreen :
/*------------------------------------------------------------------------------
 Show the current logging settings
------------------------------------------------------------------------------*/

  DEF VAR icoun# AS INT NO-UNDO.
  DEF VAR nentr# AS CHAR NO-UNDO.
  DEF VAR ntype# AS CHAR NO-UNDO.
  DEF VAR nleve# AS CHAR NO-UNDO.


  DO WITH FRAME {&FRAME-NAME}:

    IF LOG-MANAGER:LOGFILE-NAME = ? THEN
      ENABLE nfile#.
    ELSE DO:
      ASSIGN nfile#:SCREEN-VALUE = LOG-MANAGER:LOGFILE-NAME.
      DISABLE nfile#.
    END.

    FOR EACH t-log:
      ASSIGN t-log.htype#:CHECKED = FALSE
             /* t-log.hleve#:SENSITIVE = FALSE */.
    END.

    IF LOG-MANAGER:LOG-ENTRY-TYPES NE ? THEN DO:

      DO icoun# = 1 TO NUM-ENTRIES(LOG-MANAGER:LOG-ENTRY-TYPES):

        ASSIGN nentr# = ENTRY(icoun#,LOG-MANAGER:LOG-ENTRY-TYPES)
               ntype# = ENTRY(1,nentr#,":")
               nleve# = ?.

        IF NUM-ENTRIES(nentr#,":") > 1 THEN
          ASSIGN nleve# = ENTRY(2,nentr#,":").
        ELSE
          ASSIGN nleve# = STRING(LOG-MANAGER:LOGGING-LEVEL).


        FIND t-log WHERE t-log.ntype = ntype# NO-ERROR.

        IF AVAILABLE t-log THEN DO:
          ASSIGN t-log.htype#:CHECKED = TRUE.
          ASSIGN t-log.hleve#:SCREEN-VALUE = nleve# NO-ERROR.
        END.


      END.
    END.

  END.
                                  

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setLogging C-Win 
PROCEDURE setLogging :
/*------------------------------------------------------------------------------
  Set the new logging parameters entered by the user
------------------------------------------------------------------------------*/

  DEF VAR lok# AS LOGICAL NO-UNDO.                                 
  DEF VAR stype# AS CHAR NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:

    ASSIGN nfile#.

    IF LOG-MANAGER:LOGFILE-NAME = ? THEN DO:
      
      IF SEARCH(nfile#) NE ? THEN DO:

        ASSIGN FILE-INFO:FILE-NAME = nfile#.

        MESSAGE SUBSTITUTE("Do you want to replace the current version of &1?", FILE-INFO:FULL-PATHNAME)
                VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO-CANCEL UPDATE lok#.

        CASE lok#:
          WHEN ? THEN
            RETURN.
          WHEN TRUE THEN
            OS-DELETE VALUE(FILE-INFO:FULL-PATHNAME).
        END CASE.       
        
      END.

      ASSIGN LOG-MANAGER:LOGFILE-NAME = nfile#.
    END.

    IF LOG-MANAGER:LOGFILE-NAME NE ? THEN DO:

      FOR EACH t-log:

        IF t-log.htype:CHECKED THEN DO:
          ASSIGN stype# = TRIM(SUBSTITUTE("&1,&2:&3",
                                        stype#,
                                        t-log.ntype,
                                        t-log.hleve#:SCREEN-VALUE),",").
        END.
      END.

    END.


    LOG-MANAGER:LOG-ENTRY-TYPES = stype#.

  END. /* do with frame */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

