&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

&GLOBAL-DEFINE SM_CXVSCROLL 2

/* Parameters Definitions ---                                           */
DEF INPUT PARAM pcQueryId AS CHAR NO-UNDO.

/* Local Variable Definitions ---                                       */
DEF VAR ghFrame AS HANDLE NO-UNDO.
DEF VAR ghQuery     AS HANDLE NO-UNDO.
DEF VAR gcFieldList AS CHAR NO-UNDO INIT '*':U.
DEF VAR ghBrowse AS HANDLE NO-UNDO.
DEF VAR gcOpenQuery AS CHAR NO-UNDO.
DEF VAR giScrollbarWidth AS INT NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 198.6 BY 30.43.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "<insert window title>"
         HEIGHT             = 30.43
         WIDTH              = 198.6
         MAX-HEIGHT         = 30.43
         MAX-WIDTH          = 198.6
         VIRTUAL-HEIGHT     = 30.43
         VIRTUAL-WIDTH      = 198.6
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* <insert window title> */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* <insert window title> */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-RESIZED OF C-Win /* <insert window title> */
DO:

  ASSIGN ghBrowse:WIDTH = {&WINDOW-NAME}:WIDTH
         ghBrowse:HEIGHT = {&WINDOW-NAME}:HEIGHT
         ghBrowse:DOWN = ghBrowse:DOWN 
         {&WINDOW-NAME}:HEIGHT = ghBrowse:HEIGHT NO-ERROR.

  RUN resizeBrowse IN THIS-PROCEDURE.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}
       {&WINDOW-NAME}:WIDTH-PIXELS = SESSION:WIDTH-PIXELS
       {&WINDOW-NAME}:HEIGHT = SESSION:HEIGHT
       {&WINDOW-NAME}:X = 0
       {&WINDOW-NAME}:Y = 0
       ghFrame = FRAME {&FRAME-NAME}:HANDLE
       ghFrame:WIDTH = SESSION:WIDTH
       ghFrame:HEIGHT = SESSION:HEIGHT.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
  RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

RUN GetSystemMetrics ({&SM_CXVSCROLL}, OUTPUT giScrollbarWidth).

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.


/* lockWindowUpdate is used to temporarily prevent screen painting by the os */

PROCEDURE LockWindowUpdate EXTERNAL "user32.dll" :
  DEFINE INPUT PARAMETER hWndLock AS LONG NO-UNDO.
END PROCEDURE. /* LockWindowUpdate */


/* The following procedure is being used to determine the browse scrollbar width */

PROCEDURE GetSystemMetrics EXTERNAL "user32.dll" :
  DEFINE INPUT  PARAMETER nIndex  AS LONG.
  DEFINE RETURN PARAMETER iMetric AS LONG.
END PROCEDURE. /* GetSystemMetrics */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE defineQuery C-Win 
PROCEDURE defineQuery :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAM pcTables  AS CHAR.
  DEF INPUT PARAM pcQuery   AS CHAR.

  DEF VAR hBuffer AS HANDLE.
  DEF VAR iBuffer AS INT.
  DEF VAR cQuery  AS CHAR NO-UNDO.

  cQuery = pcQuery.
  CREATE QUERY ghQuery.
  DO iBuffer = 1 TO NUM-ENTRIES(pcTables):
    CREATE BUFFER hBuffer 
      FOR TABLE ENTRY(iBuffer, pcTables)
      BUFFER-NAME STRING(iBuffer, 'Table9':U).
    ghQuery:ADD-BUFFER(hBuffer). 
  END.
  
  ghQuery:QUERY-PREPARE(cQuery).
  ghQuery:QUERY-OPEN().

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  VIEW FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Realize C-Win 
PROCEDURE Realize :
/*------------------------------------------------------------------------------
  Realize the browse.
------------------------------------------------------------------------------*/
  DEFINE VARIABLE iBuf AS INT    NO-UNDO.
  DEFINE VARIABLE hBuf AS HANDLE NO-UNDO.
  DEFINE VARIABLE iField AS INT    NO-UNDO.
  DEFINE VARIABLE hField AS HANDLE NO-UNDO.
  DEFINE VARIABLE cValidation AS CHAR   NO-UNDO.
  DEFINE VARIABLE iColumn AS INT NO-UNDO.
  DEFINE VARIABLE cColumn AS CHAR NO-UNDO.
  DEFINE VARIABLE lMatch AS LOG NO-UNDO.
  DEFINE VARIABLE hColumn AS HANDLE     NO-UNDO.

  RUN LockWindowUpdate IN THIS-PROCEDURE (INPUT {&WINDOW-NAME}:HWND).

  lMatch = INDEX(gcFieldList, '*':U) > 0.

  gcOpenQuery = ghQuery:PREPARE-STRING.
  CREATE BROWSE ghBrowse
    ASSIGN FRAME = FRAME {&FRAME-NAME}:HANDLE
           QUERY = ghQuery
           X = 0
           Y = 0
           WIDTH-PIXELS = giScrollbarWidth
/*            WIDTH = FRAME {&FRAME-NAME}:WIDTH  */
           HEIGHT = FRAME {&FRAME-NAME}:HEIGHT
           VISIBLE = FALSE 
           SENSITIVE = TRUE
           READ-ONLY = YES
           SEPARATORS = TRUE
           ROW-MARKERS = FALSE
           AUTO-VALIDATE = NO
           COLUMN-RESIZABLE = YES
           COLUMN-MOVABLE   = NO
           ALLOW-COLUMN-SEARCHING = YES
           MAX-DATA-GUESS = ghQuery:NUM-RESULTS.
           .
  
  COLUMN-BLOCK:
  DO iColumn = 1 TO NUM-ENTRIES(gcFieldList):
    cColumn = ENTRY(iColumn, gcFieldList).
    DO iBuf = 1 TO ghQuery:NUM-BUFFERS:
      hBuf = ghQuery:GET-BUFFER-HANDLE(iBuf).
      DO iField = 1 TO hBuf:NUM-FIELDS:
        hField = hBuf:BUFFER-FIELD(iField).
        IF hField:EXTENT = 0
          AND ((lMatch 
                AND (CAN-DO(gcFieldList, hField:NAME) 
                     OR CAN-DO(gcFieldList, hBuf:NAME + '.':U + hField:NAME)
                    )
               ) OR
               hField:NAME = cColumn OR
               hBuf:NAME + '.':U + hField:NAME = cColumn
              )
        THEN
        DO:
          IF hField:COLUMN-LABEL = ?
          THEN ASSIGN hField:COLUMN-LABEL = hField:LABEL.

          ASSIGN hField:COLUMN-LABEL = SUBSTITUTE ("[&1]!&2"
                                                 ,hField:NAME
                                                 ,hField:COLUMN-LABEL + " "
                                                 ).
     
          IF hField:VALIDATE-EXPRESSION NE ? THEN 
          DO: 
            cValidation = hField:VALIDATE-EXPRESSION.
            hField:VALIDATE-EXPRESSION = "":U.
            hColumn = ghBrowse:ADD-LIKE-COLUMN(hField).
            hField:VALIDATE-EXPRESSION = cValidation.
          END.
          ELSE
            hColumn = ghBrowse:ADD-LIKE-COLUMN(hField). 
          
          IF NOT lMatch THEN
            NEXT COLUMN-BLOCK.
        END.
      END.
    END.
    IF lMatch THEN
      LEAVE.
  END.

  ON START-SEARCH OF ghBrowse PERSISTENT 
    RUN searchBrowse IN THIS-PROCEDURE(ghBrowse).

  /* Realize the browse in order to find the dimensions */
 
  ghBrowse:VISIBLE = TRUE NO-ERROR.

  /* Now interrogate the columns in order to set the browse width */
  ASSIGN hColumn = ghBrowse:FIRST-COLUMN.
  DO WHILE VALID-HANDLE(hColumn): 

    ASSIGN ghBrowse:WIDTH-PIXELS = MIN(ghBrowse:WIDTH-PIXELS
                                        + hColumn:WIDTH-PIXELS
                                        + 5, /* geschatte separator breedte */
                                      {&WINDOW-NAME}:WIDTH-PIXELS) - giScrollBarWidth.
           hColumn = hColumn:NEXT-COLUMN.
  END.

  ASSIGN ghBrowse:DOWN = MIN(ghBrowse:DOWN, MAX(ghQuery:NUM-RESULTS,2))
         {&WINDOW-NAME}:HEIGHT-PIXELS = MIN(ghBrowse:HEIGHT-PIXELS,SESSION:WORK-AREA-HEIGHT-PIXELS - giScrollBarWidth)
         ghBrowse:HEIGHT-PIXELS = MIN(ghBrowse:HEIGHT-PIXELS,{&WINDOW-NAME}:HEIGHT-PIXELS)
         ghBrowse:DOWN = ghBrowse:DOWN
         {&WINDOW-NAME}:HEIGHT-PIXELS = ghBrowse:HEIGHT-PIXELS
         {&WINDOW-NAME}:WIDTH = MIN(ghBrowse:WIDTH, {&WINDOW-NAME}:WIDTH)
         NO-ERROR.

  RUN resizeBrowse IN THIS-PROCEDURE.

  /* Now we can finally set the EXPANDABLE attribute */

  ASSIGN ghBrowse:EXPANDABLE = TRUE.

  RUN LockWindowUpdate IN THIS-PROCEDURE (INPUT 0).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE resizeBrowse C-Win 
PROCEDURE resizeBrowse :
/*------------------------------------------------------------------------------
  Adjust the frame and browse size to the (new) window size.
------------------------------------------------------------------------------*/

  ASSIGN ghFrame:VIRTUAL-WIDTH = {&WINDOW-NAME}:WIDTH
         ghFrame:VIRTUAL-HEIGHT = {&WINDOW-NAME}:HEIGHT
         ghFrame:WIDTH = {&WINDOW-NAME}:WIDTH
         ghFrame:HEIGHT = {&WINDOW-NAME}:HEIGHT.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE searchBrowse C-Win 
PROCEDURE searchBrowse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAM phBrowse AS HANDLE NO-UNDO.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setFieldList C-Win 
PROCEDURE setFieldList :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAM pcFieldList AS CHAR NO-UNDO.
  gcFieldList = pcFieldList.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setQueryHandle C-Win 
PROCEDURE setQueryHandle :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAM phQuery AS HANDLE NO-UNDO.
  ghQuery = phQuery.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setTTHandle C-Win 
PROCEDURE setTTHandle :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF INPUT PARAM ttHandle AS HANDLE.
DEF VAR hBuffer AS HANDLE.

IF NOT VALID-HANDLE(ttHandle) THEN
DO:
  MESSAGE PROGRAM-NAME(1) SKIP
    'Invalid temp-table handle':U
    VIEW-AS ALERT-BOX ERROR.
  RETURN ERROR.
END.

CREATE QUERY ghQuery.
CREATE BUFFER hBuffer FOR TABLE ttHandle:DEFAULT-BUFFER-HANDLE.
ghQuery:SET-BUFFERS(hBuffer).
ghQuery:QUERY-PREPARE(SUBST('FOR EACH &1 NO-LOCK':U, hBuffer:NAME)).
ghQuery:QUERY-OPEN().
/* find num-results */
ghQuery:GET-LAST().
ghQuery:GET-FIRST().

{&WINDOW-NAME}:TITLE = SUBSTITUTE ("Dynamic temp-table viewer [&1]"
                                  ,ttHandle:NAME
                                  ).

IF ttHandle:PRIVATE-DATA NE ? THEN
  ASSIGN {&WINDOW-NAME}:TITLE = SUBSTITUTE("&1 - &2",
                                           {&WINDOW-NAME}:TITLE,
                                           ttHandle:PRIVATE-DATA).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

